
####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was GridToolsConfig.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../" ABSOLUTE)

# Use original install prefix when loaded through a "/usr move"
# cross-prefix symbolic link such as /lib -> /usr/lib.
get_filename_component(_realCurr "${CMAKE_CURRENT_LIST_DIR}" REALPATH)
get_filename_component(_realOrig "/usr/lib/cmake" REALPATH)
if(_realCurr STREQUAL _realOrig)
  set(PACKAGE_PREFIX_DIR "/usr")
endif()
unset(_realOrig)
unset(_realCurr)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

get_filename_component(GRIDTOOLS_CONFIG_CMAKE_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)

message(STATUS "GridTools version 1.1.3 found at ${GRIDTOOLS_CONFIG_CMAKE_DIR}")

include(CMakeFindDependencyMacro)
find_dependency(Boost 1.58)

if(ON)
    find_dependency(MPI COMPONENTS CXX)
    include("${PACKAGE_PREFIX_DIR}/lib/cmake/workaround_mpi.cmake")
    _fix_mpi_flags()
endif()

if(ON)
    find_dependency(OpenMP COMPONENTS CXX)
endif()

include("${GRIDTOOLS_CONFIG_CMAKE_DIR}/GridToolsTargets.cmake")

set(GRIDTOOLS_HAS_BACKEND_CUDA OFF)
set(GRIDTOOLS_HAS_BACKEND_MC ON)
set(GRIDTOOLS_HAS_BACKEND_X86 ON)
set(GRIDTOOLS_HAS_BACKEND_NAIVE ON)

if(OFF)
    set(GRIDTOOLS_CUDA_COMPILATION_TYPE "NVCC-CUDA")
endif()

if(GRIDTOOLS_ENABLE_PERFORMANCE_METERS)
    target_compile_definitions(GridTools::gridtools INTERFACE GT_ENABLE_METERS)
endif()

set_and_check(GridTools_MODULE_PATH ${PACKAGE_PREFIX_DIR}/lib/cmake)
set_and_check(GridTools_INCLUDE_PATH ${PACKAGE_PREFIX_DIR}/include)

# Remove with GT 2.0 (cpp_bindgen will be fully standalone)
set(CPP_BINDGEN_GT_LEGACY ON CACHE BOOL "Enables the legacy mode for API compatibility with GridTools 1.x" FORCE)
mark_as_advanced(CPP_BINDGEN_GT_LEGACY)
find_dependency(cpp_bindgen
    HINTS ${CMAKE_CURRENT_LIST_DIR})

check_required_components(GridTools)
